#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>
#include <unistd.h>

#include <curl/curl.h>
#include <magic.h>

#include "landerctl.h"

const char default_cfg_path[] = ".landerrc";

int main(int argc, char **argv) {
  landerctl_cfg cfg;
  char *err_msg = NULL;

  switch (landerctl_cfg_parse(&cfg, default_cfg_path)) {
  case landerctl_cfg_err_ok:
    break;
  case landerctl_cfg_err_not_found:
    err_msg = "Config file not found";
    break;
  case landerctl_cfg_err_invalid:
    err_msg = "Invalid config file";
    break;
  case landerctl_cfg_err_incomplete:
    err_msg = "Incomplete config file";
    break;
  }

  if (err_msg != NULL) {
    fprintf(stderr, "%s\n", err_msg);
    exit(1);
  }

  /* struct stat sb; */

  /* stat(argv[1], &sb); */

  /* printf("file size: %lu\n", sb.st_size); */

  /* FILE *f = fopen(argv[1], "rb"); */

  /* if (f == NULL) { */
  /*   printf("Couldn't open file.\n"); */
  /*   exit(1); */
  /* } */

  /* curl_global_init(CURL_GLOBAL_ALL); */

  /* CURL *curl = curl_easy_init(); */

  /* if (curl == NULL) { */
  /*   exit(1); */
  /* } */

  /* curl_easy_setopt(curl, CURLOPT_URL, "http://localhost:18080/f/"); */
  /* curl_easy_setopt(curl, CURLOPT_UPLOAD, 1L); */
  /* curl_easy_setopt(curl, CURLOPT_READDATA, f); */

  /* curl_off_t file_size = sb.st_size; */
  /* /1* curl_easy_setopt(curl, CURLOPT_INFILESIZE_LARGE, file_size); *1/ */
  /* curl_easy_setopt(curl, CURLOPT_POST, 1L); */
  /* curl_easy_setopt(curl, CURLOPT_POSTFIELDSIZE_LARGE, file_size); */

  /* magic_t cookie = magic_open(MAGIC_MIME_TYPE); */
  /* magic_load(cookie, NULL); */
  /* const char *mime_type = magic_file(cookie, argv[1]); */

  /* char content_type_header[strlen(mime_type) + 24]; */
  /* sprintf(content_type_header, "X-Lander-Content-Type: %s", mime_type); */

  /* char content_length_header[32]; */
  /* sprintf(content_length_header, "Content-Length: %lu", sb.st_size); */

  /* struct curl_slist *list = NULL; */
  /* list = curl_slist_append(list, content_type_header); */
  /* list = curl_slist_append(list, content_length_header); */
  /* list = curl_slist_append(list, "X-Api-Key: test"); */

  /* curl_easy_setopt(curl, CURLOPT_HTTPHEADER, list); */

  /* curl_easy_setopt(curl, CURLOPT_VERBOSE, 1); */
  /* curl_easy_perform(curl); */

  /* curl_slist_free_all(list); */
}
